<?php
    require_once dirname(__FILE__).'/productHistory.class.php';

    /**
     * Dates of release for certain Thunderbird versions, mostly obtained from
     * http://en.wikipedia.org/wiki/History_of_Mozilla_Thunderbird#Release_history
     */
    class thunderbirdHistory extends productHistory {
        // Major releases
        var $major_releases = array(
                '1.0' => '2004-12-07',
                '1.5' => '2006-01-11',
                '2.0' => '2007-04-18',
                '3.0' => '2009-12-08',
                '3.1' => '2010-06-24',
                '5.0' => '2011-06-28',
                '6.0' => '2011-08-16',
                '7.0' => '2011-09-27',
                '8.0' => '2011-11-08',
                '9.0' => '2011-12-20',
                '10.0' => '2012-01-31',
                '11.0' => '2012-03-13',
                '12.0' => '2012-04-24',
                '13.0' => '2012-06-05',
                '14.0' => '2012-07-17',
                '15.0' => '2012-08-28',
                '16.0' => '2012-10-09',
                '17.0' => '2012-11-20',
                '24.0' => '2013-09-17',
                '31.0' => '2014-07-22',
                // NEXT_MAJOR
                );
                // Do not remove NEXT_MAJOR

        // Security and stability releases
        var $stability_releases = array(
                '1.0.2'    => '2005-03-21',
                '1.0.5'    => '2005-07-13',
                '1.0.6'    => '2005-07-19',
                '1.0.7'    => '2005-09-29',
                '1.0.8'    => '2006-04-21',
                '1.5.0.2'  => '2006-04-21',
                '1.5.0.4'  => '2006-06-01',
                '1.5.0.5'  => '2006-07-27',
                '1.5.0.7'  => '2006-09-14',
                '1.5.0.8'  => '2006-11-08',
                '1.5.0.9'  => '2006-12-19',
                '1.5.0.10' => '2007-03-01',
                '1.5.0.12' => '2007-05-30',
                '1.5.0.13' => '2007-08-23',
                '2.0.0.4'  => '2007-06-14',
                '2.0.0.5'  => '2007-07-19',
                '2.0.0.6'  => '2007-08-01',
                '2.0.0.9'  => '2007-11-14',
                '2.0.0.12' => '2008-02-26',
                '2.0.0.14' => '2008-05-01',
                '2.0.0.16' => '2008-07-23',
                '2.0.0.17' => '2008-09-25',
                '2.0.0.18' => '2008-11-19',
                '2.0.0.19' => '2008-12-30',
                '2.0.0.21' => '2009-03-18',
                '2.0.0.22' => '2009-06-22',
                '2.0.0.23' => '2009-08-20',
                '2.0.0.24' => '2010-03-16',
                '3.0.1' => '2010-01-20',
                '3.0.2' => '2010-02-25',
                '3.0.3' => '2010-03-01',
                '3.0.4' => '2010-03-30',
                '3.0.5' => '2010-06-17',
                '3.0.6' => '2010-07-20',
                '3.0.7' => '2010-09-07',
                '3.0.8' => '2010-09-16',
                '3.0.9' => '2010-10-19',
                '3.0.10' => '2010-10-27',
                '3.0.11' => '2010-12-09',
                '3.1.1' => '2010-07-20',
                '3.1.2' => '2010-08-05',
                '3.1.3' => '2010-09-07',
                '3.1.4' => '2010-09-16',
                '3.1.5' => '2010-10-19',
                '3.1.6' => '2010-10-27',
                '3.1.7' => '2010-12-09',
                '3.1.8' => '2011-03-01',
                '3.1.9' => '2011-03-04',
                '3.1.10' => '2011-04-28',
                '3.1.11' => '2011-06-21',
                '3.1.12' => '2011-08-24',
                '3.1.13' => '2011-08-31',
                '3.1.14' => '2011-09-06',
                '3.1.15' => '2011-09-27',
                '3.1.16' => '2011-11-08',
                '3.1.17' => '2011-12-20',
                '3.1.18' => '2012-01-31',
                '3.1.19' => '2012-02-16',
                '3.1.20' => '2012-03-13',
                '6.0.1' => '2011-08-31',
                '6.0.2' => '2011-09-06',
                '7.0.1' => '2011-09-30',
                '9.0.1' => '2011-12-23',
                '10.0.1' => '2012-02-12',
                '10.0.2' => '2012-02-16',
                '11.0.1' => '2012-03-28',
                '12.0.1' => '2012-04-30',
                '13.0.1' => '2012-06-15',
                '15.0.1' => '2012-09-10',
                '16.0.1' => '2012-10-11',
                '16.0.2' => '2012-10-29',
                '17.0.2' => '2013-01-08',
                '17.0.3' => '2013-02-19',
                '17.0.4' => '2013-03-11',
                '17.0.5' => '2013-04-02',
                '17.0.6' => '2013-05-14',
                '17.0.7' => '2013-06-25',
                '17.0.8' => '2013-08-06',
                '17.0.9' => '2013-09-17',
                '17.0.10' => '2013-10-29',
                '24.0.1' => '2013-10-11',
                '24.1.0' => '2013-10-29',
                '24.1.1' => '2013-11-19',
                '24.2.0' => '2013-12-10',
                '24.3.0' => '2014-02-04',
                '24.4.0' => '2014-03-18',
                '24.5.0' => '2014-04-29',
                '24.6.0' => '2014-04-29',
                '24.7.0' => '2014-07-28',
                '24.8.0' => '2014-09-02',
                '31.1.0' => '2041-09-02',
                '31.1.1' => '2041-09-10',
                '31.1.2' => '2041-09-24',
                // NEXT_STABILITY
                );
                // Do not remove NEXT_STABILITY

        // Development releases - betas and release candidates only
        var $development_releases = array(
                '1.0rc1' => '2004-12-01',
                '1.5b1'  => '2005-09-09',
                '1.5b2'  => '2005-10-07',
                '1.5rc1' => '2005-11-05',
                '1.5rc2' => '2005-12-21',
                '2.0b1'  => '2006-12-12',
                '2.0b2'  => '2007-01-23',
                '2.0rc1' => '2007-04-06',
                '3.0a1'  => '2008-05-12',
                '3.0a2'  => '2008-07-13',
                '3.0a3'  => '2008-10-14',
                '3.0b1'  => '2008-12-09',
                '3.0b2'  => '2009-02-26',
                '3.0b3'  => '2009-07-21',
                '3.0b4'  => '2009-10-22',
                '3.0rc1' => '2009-11-24',
                '3.0rc2' => '2009-12-01',
                '3.1a1'  => '2010-02-03',
                '3.1b1'  => '2010-03-10',
                '3.1rc1' => '2010-05-27',
                '3.1rc2' => '2010-06-09',
                '3.3a1'  => '2010-11-23',
                '3.3a2'  => '2011-01-20',
                '3.3a3'  => '2011-03-15',
                '5.0b1'  => '2011-06-02',
                '6.0b1' => '2011-07-20',
                '6.0b2' => '2011-08-02',
                '6.0b3' => '2011-08-10',
                // NEXT_DEVELOPMENT
                );
                // Do not remove NEXT_DEVELOPMENT
    }

?>
