<?php
    require_once dirname(__FILE__).'/productHistory.class.php';

    /**
     * Dates of release for certain Firefox Mobile versions
     */
    class mobileHistory extends productHistory {
        // Major releases
        var $major_releases = array(
                '1.0' => '2010-01-28',
                '1.1' => '2010-07-01',
                '4.0' => '2011-03-29',
                '5.0' => '2011-06-21',
                '6.0' => '2011-08-16',
                '7.0' => '2011-09-27',
                '8.0' => '2011-11-08',
                '9.0' => '2011-12-20',
                '10.0' => '2012-01-31',
                '14.0' => '2012-06-26',
                '14.0.1' => '2012-07-17',
                '15.0' => '2012-08-28',
                '16.0' => '2012-10-09',
                '17.0' => '2012-11-19',
                '18.0' => '2013-01-08',
                '19.0' => '2013-02-19',
                '20.0' => '2013-04-02',
                '21.0' => '2013-05-14',
                '22.0' => '2013-06-25',
                '23.0' => '2013-08-06',
                '24.0' => '2013-09-17',
                '25.0' => '2013-10-29',
                '26.0' => '2013-12-10',
                '27.0' => '2014-02-04',
                '28.0' => '2014-03-18',
                '29.0' => '2014-04-29',
                '30.0' => '2014-06-10',
                '31.0' => '2014-07-22',
                '32.0' => '2014-09-02',
                // NEXT_MAJOR
                );
                // Do not remove NEXT_MAJOR

        // Security and stability releases
        var $stability_releases = array(
                '1.0.1'    => '2010-04-13',
                '4.0.1'    => '2011-04-28',
                // No 5.0.1 as it was a respin for a non-mobile platform
                // No 6.0.1 as we got new info before it was released, prompting 6.0.2
                '6.0.2'    => '2011-09-06',
                '7.0.1'    => '2011-09-29',
                '10.0.1'    => '2012-02-10',
                '10.0.2'    => '2012-02-16',
                '10.0.3'    => '2012-03-13',
                '10.0.4'    => '2012-04-24',
                '10.0.5'    => '2012-06-05',
                '14.0.1'    => '2012-07-17',
                '15.0.1'    => '2012-09-06',
                '16.0.1'    => '2012-10-11',
                '16.0.2'    => '2012-10-26',
                '18.0.2'    => '2012-02-07',
                '19.0.2'    => '2013-03-07',
                '20.0.1'    => '2013-04-11',
                '25.0.1'    => '2013-11-15',
                '26.0.1'    => '2013-12-20',
                '28.0.1'    => '2014-03-24',
                '29.0.1'    => '2014-05-09',
                '32.0.1'    => '2014-09-10',
                // No 32.0.2 as this was a desktop stability release
                '32.0.3'    => '2014-09-24',
                '31.1.1'    => '2014-09-24',
                // NEXT_STABILITY
                );
                // Do not remove NEXT_STABILITY

        // Development releases - betas and release candidates only
        var $development_releases = array(
                '1.1b1' => '2010-04-28',
                '1.1rc1' => '2010-06-16',
                '4.0b1' => '2010-10-06',
                '4.0b2' => '2010-11-04',
                '4.0b3' => '2010-12-22',
                '4.0b4' => '2011-02-01',
                '4.0b5' => '2011-02-23',
                '4.0rc1' => '2011-03-21',
                '5.0b1' => '2011-05-20',
                '5.0b4' => '2011-06-07',
                '5.0b7' => '2011-06-15',
                '6.0b1' => '2011-07-08',
                '6.0b2' => '2011-07-15',
                '6.0b3' => '2011-07-25',
                '6.0b4' => '2011-08-01',
                '6.0b5' => '2011-08-05',
                '7.0b1' => '2011-08-18',
                '7.0b2' => '2011-08-26',
                // No b3
                '7.0b4' => '2011-09-06',
                '7.0b5' => '2011-09-09',
                '7.0b6' => '2011-09-19',
                '8.0b1' => '2011-09-29',
                '8.0b2' => '2011-10-10',
                '8.0b3' => '2011-10-14',
                '8.0b4' => '2011-10-21',
                '8.0b5' => '2011-10-28',
                '8.0b6' => '2011-11-03',
                '9.0b1' => '2011-11-10',
                '9.0b2' => '2011-11-17',
                '9.0b3' => '2011-11-25',
                '9.0b4' => '2011-12-02',
                '9.0b5' => '2011-12-09',
                '9.0b6' => '2011-12-15',
                '10.0b1' => '2011-12-22',
                '10.0b2' => '2011-12-30',
                '10.0b3' => '2012-01-06',
                '10.0b4' => '2012-01-13',
                '10.0b5' => '2012-01-20',
                '10.0b6' => '2012-01-26',
                '11.0b3' => '2012-02-17',
                '11.0b4' => '2012-02-24',
                '11.0b5' => '2012-03-02',
                '11.0b6' => '2012-03-07',
                '12.0b1' => '2012-03-16',
                '12.0b2' => '2012-03-23',
                '12.0b3' => '2012-03-30',
                '12.0b4' => '2012-04-05',
                '12.0b5' => '2012-04-13',
                '12.0b6' => '2012-04-19',
                '13.0b1' => '2012-04-27',
                '13.0b2' => '2012-05-03',
                '14.0b1' => '2012-05-15',
                '14.0b2' => '2012-05-18',
                '14.0b3' => '2012-05-25',
                '14.0b4' => '2012-06-01',
                '14.0b5' => '2012-06-01',
                '14.0b6' => '2012-06-07',
                '14.0b7' => '2012-06-13',
                '14.0b8' => '2012-06-21',
                // no b9
                '14.0b10' => '2012-06-29',
                '14.0b11' => '2012-07-06',
                '14.0b12' => '2012-07-11',
                '15.0b1' => '2012-07-19',
                '15.0b2' => '2012-07-27',
                '15.0b3' => '2012-08-02',
                '15.0b4' => '2012-08-10',
                '15.0b5' => '2012-08-17',
                '15.0b6' => '2012-08-22',
                '15.0b7' => '2012-08-24',
                '16.0b1' => '2012-08-30',
                '16.0b2' => '2012-09-07',
                '16.0b3' => '2012-09-14',
                '16.0b4' => '2012-09-21',
                '16.0b5' => '2012-09-27',
                '16.0b6' => '2012-10-03',
                '17.0b1' => '2012-10-11',
                '17.0b2' => '2012-10-19',
                '17.0b3' => '2012-10-24',
                '17.0b4' => '2012-11-02',
                '17.0b5' => '2012-11-08',
                '17.0b6' => '2012-11-14',
                '17.0b7' => '2012-11-16',
                '18.0b1' => '2012-11-26',
                '18.0b2' => '2012-11-29',
                '18.0b3' => '2012-12-06',
                '18.0b4' => '2012-12-14',
                '18.0b5' => '2012-12-21',
                '18.0b6' => '2012-12-28',
                '18.0b7' => '2013-01-02',
                '19.0b1' => '2013-01-10',
                '19.0b2' => '2013-01-18',
                '19.0b3' => '2013-01-25',
                '19.0b4' => '2013-02-01',
                '19.0b5' => '2013-02-07',
                '19.0b6' => '2013-02-13',
                '20.0b1' => '2013-02-25',
                '20.0b2' => '2013-03-01',
                '20.0b4' => '2013-03-08',
                '20.0b5' => '2013-03-15',
                '20.0b6' => '2013-03-22',
                '21.0b1' => '2013-04-04',
                '21.0b2' => '2013-04-11',
                '21.0b3' => '2013-04-19',
                '21.0b4' => '2013-04-25',
                '21.0b6' => '2013-05-02',
                '21.0b7' => '2013-05-07',
                '22.0b1' => '2013-05-16',
                '22.0b2' => '2013-05-23',
                '22.0b3' => '2013-05-30',
                '22.0b4' => '2013-06-07',
                '22.0b5' => '2013-06-14',
				'22.0b6' => '2013-06-19',
				'23.0b1' => '2013-06-27',
				'23.0b2' => '2013-07-02',
                '23.0b4' => '2013-07-10',
                '23.0b6' => '2013-07-17',
                '23.0b8' => '2013-07-24',
                '23.0b10' => '2013-07-31',
                '24.0b1' => '2013-08-09',
                '24.0b4' => '2013-08-20',
                '24.0b8' => '2013-09-06',
                '24.0b10' => '2013-09-11',
                '25.0b1' => '2013-09-18',
                '25.0b2' => '2013-09-24',
                '25.0b4' => '2013-10-02',
                '25.0b6' => '2013-10-09',
                '25.0b8' => '2013-10-16',
                '25.0b10' => '2013-10-22',
                '26.0b1' => '2013-10-31',
                '26.0b2' => '2013-11-06',
                '26.0b4' => '2013-11-14',
                '26.0b6' => '2013-11-20',
                '26.0b8' => '2013-11-27',
                '26.0b10' => '2013-12-04',
                '27.0b1' => '2013-12-12',
                '27.0b2' => '2013-12-18',
                '27.0b4' => '2014-01-08',
                '27.0b6' => '2014-01-14',
                '27.0b8' => '2014-01-22',
                '27.0b9' => '2014-01-24',
                '28.0b1' => '2014-02-06',
                '28.0b2' => '2014-02-11',
                '28.0b4' => '2014-02-20',
                '28.0b6' => '2014-02-26',
                '28.0b8' => '2014-03-05',
                '29.0b1' => '2014-03-20',
                '29.0b2' => '2014-03-26',
                '29.0b4' => '2014-04-02',
                '29.0b6' => '2014-04-08',
                '29.0b8' => '2014-04-15',
                '29.0b10' => '2014-04-23',
                '30.0b1' => '2014-05-01',
                '30.0b2' => '2014-05-07',
                '30.0b4' => '2014-05-14',
                '30.0b6' => '2014-05-21',
                '30.0b8' => '2014-05-28',
                '30.0b10' => '2014-06-04',
                '31.0b1' => '2014-06-12',
                '31.0b2' => '2014-06-17',
                '31.0b4' => '2014-06-26',
                '31.0b6' => '2014-07-01',
                '31.0b8' => '2014-07-08',
                '31.0b10' => '2014-07-15',
                '31.0b11' => '2014-07-17',
                '32.0b1' => '2014-07-24',
                '32.0b2' => '2014-07-29',
                '32.0b4' => '2014-08-06',
                '32.0b6' => '2014-08-13',
                '32.0b8' => '2014-08-20',
                '32.0b10' => '2014-08-26',
                '33.0b1' => '2014-09-05',
                '33.0b2' => '2014-09-09',
                '33.0b4' => '2014-09-17',
		'33.0b6' => '2014-09-23',
                '33.0b7' => '2014-09-24',
                // NEXT_DEVELOPMENT
                );
                // Do not remove NEXT_DEVELOPMENT
    }

?>
